﻿
Imports System.Web.UI

Partial Class envelopedit
    Inherits System.Web.UI.Page

    Const ST_MAIL_COUNT As Integer = 0, ST_MAILTO As Integer = 1, ST_MAILTO_CSV_FILE As Integer = 2
    Const ST_BODY_FILE As Integer = 3, ST_ATTACH_FILE As Integer = 4, ST_SUBJECT As Integer = 5
    Const ST_MAILFROM As Integer = 6, ST_MAIL_CC As Integer = 7, ST_MAIL_BCC As Integer = 8
    Const ST_MAIL_HEADER As Integer = 9, ST_SERVER As Integer = 10, ST_PLAN_DATETIME As Integer = 11
    Const ST_START_DATETIME As Integer = 12, ST_END_DATETIME As Integer = 13, ST_SENT_COUNT As Integer = 14
    Const ST_NG_COUNT As Integer = 15, ST_LOGFILE As Integer = 16, ST_TEST_MAILTO As Integer = 17
    Const ST_EXCEL_SHEETNAME As Integer = 18, ST_COL_POS As Integer = 19, ST_MESSAGE_ID As Integer = 20
    Const ST_BCC_TO_HEADER As Integer = 21, ST_RSV1 As Integer = 22, ST_RSV2 As Integer = 23, ST_RSV3 As Integer = 24
    Const ST_END As Integer = 25
    Const MAX_BCC As Integer = 4000, STATUS_FILE As String = "\status.txt"
    Const THIS_VERSION As String = "BEnvelop 1.0"
    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load


        If Not Page.IsPostBack Then
            ' 封筒ベースフォルダ名取得
            Dim envelop_base As String = System.Configuration.ConfigurationManager.AppSettings("envelop_base")
            ods.SelectParameters("name").DefaultValue = envelop_base
            Dim envelop As String = Request.QueryString("envelop")
            Dim envelop_encode As String = Server.UrlEncode(envelop)

            mailtoupload.NavigateUrl = "fileupload.aspx?ftype=mailto&envelop=" & envelop_encode
            bodyupload.NavigateUrl = "fileupload.aspx?ftype=body&envelop=" & envelop_encode
            attachupload.NavigateUrl = "fileupload.aspx?ftype=attach&envelop=" & envelop_encode

            mailtodownload.NavigateUrl = "download.aspx?ftype=mailto&envelop=" & envelop_encode
            bodydownload.NavigateUrl = "download.aspx?ftype=body&envelop=" & envelop_encode
            attachdownload.NavigateUrl = "download.aspx?ftype=attach&envelop=" & envelop_encode
            logdownload.NavigateUrl = "download.aspx?ftype=log&envelop=" & envelop_encode

            ViewState("envelop") = envelop
            ViewState("envelop_base") = envelop_base
            ViewState("mypath") = envelop_base & "\" & envelop & "\"
            title.Text = "封筒名：" & envelop
            Dim statusfile As String = envelop_base & "\" & envelop & STATUS_FILE
            Dim status() As String = read_status(statusfile)
            set_screen(status)
            ViewState("statusfile") = statusfile
            ViewState("status") = status

            DropDownListEnvelop.DataBind()
            DropDownListEnvelop.Items.Remove(envelop) ' 自分自身を表示しない

            Dim bobj As BASP21PROLib.basp21p = New BASP21PROLib.basp21p
            Dim pos As Integer = InStrRev(bobj.Version, "\")
            poweredby.Text = THIS_VERSION & " Powered by " & Mid(bobj.Version, pos + 1)
            bobj = Nothing

        End If
        msg.Text = "" : msgok.Text = ""

    End Sub


    ' 封筒情報読込み
    Function read_status(ByVal statusfile As String) As String()
        Dim sr As System.IO.StreamReader
        Try
            sr = New System.IO.StreamReader(statusfile, System.Text.Encoding.Default)
        Catch ex As Exception
            Return Split(New String(Environment.NewLine, ST_END), Environment.NewLine)
        End Try
        Dim strBuffer As String
        strBuffer = sr.ReadToEnd()
        sr.Close()
        strBuffer = strBuffer.Replace(Environment.NewLine, vbCr)
        Return strBuffer.Split(vbCr)
    End Function



    Protected Function copy_envelop(ByVal envelop_path2 As String, ByVal envelop_path1 As String) As String()
        Dim status1() As String, status2() As String
        Dim statusfile1 As String, statusfile2 As String

        statusfile1 = envelop_path1 & STATUS_FILE
        statusfile2 = envelop_path2 & STATUS_FILE
        status2 = read_status(statusfile2)
        Try
            If status2(ST_MAILTO_CSV_FILE) <> "" Then
                System.IO.File.Copy(envelop_path2 & "\" & status2(ST_MAILTO_CSV_FILE), _
                 envelop_path1 & "\" & status2(ST_MAILTO_CSV_FILE))
            End If
            If status2(ST_BODY_FILE) <> "" Then
                System.IO.File.Copy(envelop_path2 & "\" & status2(ST_BODY_FILE), _
                 envelop_path1 & "\" & status2(ST_BODY_FILE))
            End If
            If status2(ST_ATTACH_FILE) <> "" Then
                System.IO.File.Copy(envelop_path2 & "\" & status2(ST_ATTACH_FILE), _
                 envelop_path1 & "\" & status2(ST_ATTACH_FILE))
            End If
        Catch ex As Exception
            msg.Text = "ファイルのコピーに失敗 " & ex.Message
            Return status2
        End Try
        status1 = status2
        status1(ST_PLAN_DATETIME) = ""
        status1(ST_START_DATETIME) = ""
        status1(ST_END_DATETIME) = ""
        status1(ST_SENT_COUNT) = ""
        status1(ST_NG_COUNT) = ""
        status1(ST_LOGFILE) = ""
        status1(ST_MESSAGE_ID) = ""
        msg.Text = write_status(statusfile1, status1)
        If Len(msg.Text) > 0 Then
            msgok.Text = "コピーしました"
        End If
        Return status1
    End Function
    Protected Function write_status(ByVal statusfile As String, status() As String) As String
        Dim emsg As String = ""
        Try
            Dim sw As New System.IO.StreamWriter(statusfile, False, System.Text.Encoding.GetEncoding("Shift_Jis"))
            Dim sx As String = Join(status, Environment.NewLine)
            sw.Write(sx)
            sw.Close()
        Catch e As System.IO.IOException
            emsg = "ファイルの書き込みに失敗 " & statusfile
        End Try
        Return emsg
    End Function

    Protected Sub ButtonCopy_Click(sender As Object, e As EventArgs) Handles ButtonCopy.Click
        Dim envelop1 As String = DropDownListEnvelop.SelectedValue
        Dim envelop As String = ViewState("envelop")
        Dim envelop_base As String = ViewState("envelop_base")

        Dim status() As String = copy_envelop(envelop_base & "\" & envelop1, _
                                              envelop_base & "\" & envelop)

        set_screen(status)

    End Sub
    Protected Sub set_screen(ByVal status() As String)

        datetime.Text = status(ST_PLAN_DATETIME)
        sentdate.Text = status(ST_END_DATETIME)
        mailcount.Text = status(ST_SENT_COUNT)
        subject.Text = status(ST_SUBJECT)

        If status(ST_MAILTO_CSV_FILE) <> "" Then
            usemailtofile.Checked = True
            mailto.Enabled = False
            mailto.Text = status(ST_MAILTO_CSV_FILE)
            mailtodownload.Enabled = True
            ButtonDelmailto.Enabled = True
        Else
            usemailtofile.Checked = False
            mailto.Enabled = True
            mailto.Text = status(ST_MAILTO)
        End If

        If status(ST_BODY_FILE) <> "" Then
            bodydownload.Enabled = True
            ButtonDelbody.Enabled = True
        End If
        If status(ST_ATTACH_FILE) <> "" Then
            attachdownload.Enabled = True
            ButtonDelattach.Enabled = True
        End If
        If status(ST_LOGFILE) <> "" Then
            logdownload.Enabled = True
        End If

        bodyfile.Text = status(ST_BODY_FILE)
        attachfile.Text = status(ST_ATTACH_FILE)

        bcctoheader.Text = status(ST_BCC_TO_HEADER)


        mailfrom.Text = status(ST_MAILFROM)
        mailcc.Text = status(ST_MAIL_CC)
        mailbcc.Text = status(ST_MAIL_BCC)
        mailheader.Text = status(ST_MAIL_HEADER)

        sheetname.Text = status(ST_EXCEL_SHEETNAME)
        colpos.Text = status(ST_COL_POS)
        mserver.Text = status(ST_SERVER)
        testmailto.Text = status(ST_TEST_MAILTO)

        Buttontestmail.Enabled = False
        If Len(testmailto.Text) > 0 And Len(mailfrom.Text) > 0 _
            And Len(subject.Text) > 0 And Len(bodyfile.Text) > 0 And Len(mserver.Text) > 0 Then
            Buttontestmail.Enabled = True
        End If


    End Sub


    Protected Sub ButtonSave_Click(sender As Object, e As EventArgs) Handles ButtonSave.Click

        Dim statusfile As String = ViewState("statusfile")
        Dim status() As String = ViewState("status")
 
        If Len(datetime.Text) > 0 Then ' 送信予定日チェック
            Dim dates As String = datetime.Text
            If Len(dates) < 16 Then
                msg.Text = "送信予定日時(形式) YYYY/MM/DD HH:MM"
            End If
            If Not IsDate(dates) Then
                msg.Text = "送信予定日時(形式) YYYY/MM/DD HH:MM"
            End If
            If DateDiff("n", Now(), dates) < 1 Then
                msg.Text = "送信予定日時(過去)"
            End If
        End If
        If Len(msg.Text) > 0 Then
            Exit Sub
        End If
        status(ST_PLAN_DATETIME) = datetime.Text
        If status(ST_MAILTO_CSV_FILE) = "" Then
            status(ST_MAILTO) = mailto.Text
        End If
        status(ST_SUBJECT) = subject.Text
        status(ST_BCC_TO_HEADER) = bcctoheader.Text
        status(ST_MAILFROM) = mailfrom.Text
        status(ST_MAIL_CC) = mailcc.Text
        status(ST_MAIL_BCC) = mailbcc.Text
        status(ST_MAIL_HEADER) = mailheader.Text

        status(ST_EXCEL_SHEETNAME) = sheetname.Text
        status(ST_COL_POS) = colpos.Text
        status(ST_SERVER) = mserver.Text
        status(ST_TEST_MAILTO) = testmailto.Text


        If checkplandate.Checked = True Then
            reset_plandate(status)
        End If

        msg.Text = write_status(statusfile, status)
        If Len(msg.Text) = 0 Then
            msgok.Text = "保存しました"
        End If

    End Sub

    ' 送信予定日リセット
    Protected Sub reset_plandate(ByRef status() As String)
        status(ST_PLAN_DATETIME) = "" : datetime.Text = ""
        status(ST_START_DATETIME) = ""
        status(ST_END_DATETIME) = ""
        status(ST_SENT_COUNT) = ""
        status(ST_NG_COUNT) = ""
        status(ST_MESSAGE_ID) = ""
    End Sub


    Protected Sub Buttontestmail_Click(sender As Object, e As EventArgs) Handles Buttontestmail.Click
        Dim bobj As BASP21PROLib.basp21p = New BASP21PROLib.basp21p
        Dim status() As String = ViewState("status")
        Dim mypath As String = ViewState("mypath")

        bobj.Server = status(ST_SERVER)
        bobj.MailQueue = ""
        bobj.MailFrom = status(ST_MAILFROM)
        Dim body_file As String = mypath & status(ST_BODY_FILE)
        Dim attach_file As String = ""
        If status(ST_ATTACH_FILE) <> "" Then attach_file = mypath & status(ST_ATTACH_FILE)

        Dim sr As System.IO.StreamReader = New System.IO.StreamReader(body_file, System.Text.Encoding.Default)
        Dim body As String
        body = sr.ReadToEnd()
        sr.Close()
        body = Replace(body, "%1%", para1.Text)
        body = Replace(body, "%2%", para2.Text)
        Dim mailtodata As String = status(ST_TEST_MAILTO)
        If status(ST_BCC_TO_HEADER) = "" Then
            If status(ST_MAIL_CC) <> "" Then
                mailtodata = mailtodata & ",cc," & status(ST_MAIL_CC)
            End If
            If status(ST_MAIL_BCC) <> "" Then
                mailtodata = mailtodata & ",bcc," & status(ST_MAIL_BCC)
            End If
        Else  ' BCCとして送信
            mailtodata = "@" & status(ST_BCC_TO_HEADER) & ",bcc," & status(ST_TEST_MAILTO)
            If status(ST_MAIL_BCC) <> "" Then
                mailtodata = mailtodata & "," & status(ST_MAIL_BCC)
            End If
            If status(ST_MAIL_CC) <> "" Then
                mailtodata = mailtodata & ",cc," & status(ST_MAIL_CC)
            End If
        End If
        If status(ST_MAIL_HEADER) <> "" Then
            mailtodata = mailtodata & ",>" & Replace(status(ST_MAIL_HEADER), ",", ",>")
        End If

        Dim rc As Integer = bobj.SendMail(mailtodata, status(ST_SUBJECT), body, attach_file)
        If rc = 1 Then
            msgok.Text = "送信しました " & status(ST_TEST_MAILTO)
        Else
            msg.Text = bobj.LastMsg
        End If
        bobj = Nothing
    End Sub

    Protected Sub ButtonDelattach_Click(sender As Object, e As EventArgs) Handles ButtonDelattach.Click
        Dim statusfile As String = ViewState("statusfile")
        Dim status() As String = ViewState("status")
        Dim mypath As String = ViewState("mypath")
        Dim filename As String = mypath & status(ST_ATTACH_FILE)
        System.IO.File.Delete(filename)
        status(ST_ATTACH_FILE) = "" : attachfile.Text = ""
        msg.Text = write_status(statusfile, status)
        ViewState("status") = status
        ButtonDelattach.Enabled = False
    End Sub

    Protected Sub ButtonDelbody_Click(sender As Object, e As EventArgs) Handles ButtonDelbody.Click
        Dim statusfile As String = ViewState("statusfile")
        Dim status() As String = ViewState("status")
        Dim mypath As String = ViewState("mypath")
        Dim filename As String = mypath & status(ST_BODY_FILE)
        System.IO.File.Delete(filename)
        status(ST_BODY_FILE) = "" : bodyfile.Text = ""
        msg.Text = write_status(statusfile, status)
        ViewState("status") = status
        ButtonDelbody.Enabled = False

    End Sub

    Protected Sub ButtonDelmailto_Click(sender As Object, e As EventArgs) Handles ButtonDelmailto.Click
        Dim statusfile As String = ViewState("statusfile")
        Dim status() As String = ViewState("status")
        Dim mypath As String = ViewState("mypath")
        Dim filename As String = mypath & status(ST_MAILTO_CSV_FILE)
        System.IO.File.Delete(filename)
        status(ST_MAILTO_CSV_FILE) = "" : mailto.Text = ""
        msg.Text = write_status(statusfile, status)
        ViewState("status") = status
        ButtonDelmailto.Enabled = False

    End Sub

    End Class
